/* Roguelike...
 * Zaoenia:
 *  I    - programujemy STRUKTURALNIE
 *  II   - nie komplikujemy rzeczy, ktrych komplikowa nie musimy
 *  III  - to ma by przede wszystkim dobra zabawa! */
#define _GNU_SOURCE
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>

#include "config.h"
#include "structpostac.h"
#include "ekran.h"
#include "io.h"
#include "structprzedmioty.h"
#include "structprzedmiotyID.h"
#include "przedmioty.h"
#include "structpoziom.h"
#include "poziom.h"
#include "postac.h"
#include "structpotwor.h"
#include "umiejetnosci.h"
#include "potwor.h"
#include "punkty.h"
#include "walka.h"
#include "swiat.h"
#include "schematekwipunku.h"
#include "czas.h"
#include "strefy.h"

void init_()
{
    char tmp[50];
#ifdef DEBUG
    god_mode = 0;
    clipping = 0;
    pokazuj_parametry = 0;
    widzenie_wszystkiego = 0;
#endif
    /* Locale */
    init_locale();
    /* Inicjalizacja ekranu */
    init();
    /* Inicjalizacja FOV */
    komunikat(_("Inicjalizacja FOV...\n"));
    init_fov();
    /* Inicjalizacja I/O */
    komunikat(_("Inicjalizacja I/O...\n"));
    init_io();
    /* RNG... */
    komunikat(_("Inicjalizacja RNG...\n"));
    srandom(time(NULL));
    /* Inicjalizacja mapy klawiatury */
    komunikat(_("Inicjalizacja mapy klawiatury...\n"));
    init_keymap();
    /* Inicjalizacja wiata :) */
    komunikat(_("Inicjalizacja tablic wiata...\n"));
    init_swiata();
    /* Inicjalizacja czasu :) :) */
    komunikat(_("Inicjalizacja systemu czasu...\n"));
    init_czasu();
    /* Inicjalizacja tablicy ksiek */
    komunikat(_("Inicjalizacja tablicy ksiek...\n"));
    init_ksiazek();
    /* Umiejtnoci */
    komunikat(_("Inicjalizacja systemu umiejtnoci...\n"));
    init_umiejetnosci();
    /* adowanie tablicy potworw */
    komunikat(_("adowanie tablicy potworw...\n"));
    ustaw_plik(&Plik, "POTW04");
    wczytaj_tablice_potw_ID(&Plik, &potworyID);
    /* adowanie tablicy niezidentyfikowanych przedmiotw */
    komunikat(_
	      ("adowanie tablicy niezidentyfikowanych przedmiotw...\n"));
    ustaw_plik(&Plik, "PRDM0J");
    wczytaj_tablice_preID(&Plik);
    /* adowanie tablicy przedmiotw */
    komunikat(_("adowanie tablicy przedmiotw...\n"));
    ustaw_plik(&Plik, "PRDM05");
    wczytaj_tablice_prz_ID(&Plik, &przedmiotyID);
    /* adowanie tablicy materiaw */
    komunikat(_("adowanie tablicy materiaw...\n"));
    init_materialow();
    /* adowanie schematw ekwipunku */
    komunikat(_("adowanie schematw ekwipunku...\n"));
    ustaw_plik(&Plik, "SCHM06");
    wczytaj_schematy_ekwipunku(&Plik, sch_ekw);
    /* adowanie schematw anatomii */
    komunikat(_("adowanie schematw anatomii...\n"));
    ustaw_plik(&Plik, "SCHA0I");
    wczytaj_schematy_anatomii(&Plik);
    /* Inicjalizacja terenw */
    komunikat(_("Inicjalizacja tablic terenw...\n"));
    init_terenow();
    /* Inicjalizacja punktw */
    komunikat(_("Inicjalizacja systemu punktw...\n"));
    init_punktow();
    /* Utworzenie tablicy liter (do obsugi przedmiotw) */
    strcpy(literki, "ABCDEFGHIJKLMNOPQRSTUVWYX");
    /* Inicjalizacja zmiennych do obsugi prdkoci potworw */
    licznik_szybkosci = 1;
    max_szybkosc = 1000;
    /* Hmm... Jeszcze yjemy... */
    strcpy(powod_smierci, "");
    /* Ustawienie systemu tur */
    tura = 1;
    wclear(wEkran);
    wrefresh(wEkran);
    if (zapytaj_o_zapis()) {
	laduj();
    } else {
	/* adowanie poziomu startowego */
	ustaw_plik(&Plik, "MSTO21");
	laduj_poziom(&Plik, &Poziom);
	strcpy(Poziom.nazwa, "MSTO21");
	policz_czestosci(Poziom.poziom, &przedmiotyID);
	/* Trasy */
	wyczysc_trasy();
	ustaw_plik(&Plik, "MSTO2D");
	laduj_trasy(&Plik);
	/* Miejsca */
	wyczysc_miejsca();
	ustaw_plik(&Plik, "MSTO2C");
	laduj_miejsca(&Plik);
	/* Puapki */
	wyczysc_pulapki();
	ustaw_plik(&Plik, "MSTO2E");
	laduj_pulapki(&Plik);
	/* Ustawienie przedmiotw */
	Poziom.Przedmioty.ile = 0;
	ustaw_plik(&Plik, "MSTO2H");
	wczytaj_przedmioty_kr(&Plik, &Poziom.Przedmioty);
	/* Strefy */
	wyczysc_strefy();
	ustaw_plik(&Plik, "MSTO2A");
	wczytaj_strefy(&Plik);
	/* Ustawianie postaci w miecie... */
	Poziom.Istoty.ile = 0;
	/* ... gracza... */
	dodaj_postac(Poziom.poczx, Poziom.poczy, 0, FLAGA_GRACZA,
		     Poziom.poziom, &Poziom.Istoty);
	zrob_postac(Gracz);
	tworz_postac(Gracz);
	zrob_ekwipunek(Gracz, Poziom.poziom);
	/* ... i innych */
	ustaw_plik(&Plik, "MSTO27");
	wczytaj_potwory_kr(&Plik, &Poziom.Istoty);
    }
    /* Ustawienie okienka */
    ustaw_okienko(&Poziom, Gracz->x, Gracz->y);
/* Wywietlenie wersji */
    wyczysc_gore();
#ifndef DEBUG
    strncpy(tmp, "LIB, ver. " VERSION, 50);
#else
    strncpy(tmp, "LIB, ver. " VERSION "(debug) ", 50);
#endif
    dodaj_napis(tmp);
    gora[0] = '\0';
}

int main(int argc, char *argv[])
{
    char tmp2[500];		/* do powodu mierci... */
    int tempek;			/* do punktw */
    int opcja;
    laduj_mape = 1;
    czytaj_konfiguracje_postaci = 1;
    while ((opcja = getopt(argc, argv, "hkc")) != -1)
	switch (opcja) {
	case 'h':
	    printf(_("LIB, wersja "));
	    printf(VERSION);
#ifdef DEBUG
	    printf(_("(debug)"));
#endif
	    printf(_
		   ("\n\nUycie: LIB [-hkc]\n\n -h         Pomoc\n -k         Ignorowanie pliku z map klawiatury\n -c         Ignorowanie pliku z konfiguracj postaci\n"));
	    return EXIT_SUCCESS;
	    break;
	case 'k':
	    laduj_mape = 0;
	    break;
	case 'c':
	    czytaj_konfiguracje_postaci = 0;
	    break;
	case '?':
	    if (isprint(optopt))
		fprintf(stderr, _("Nierozpoznana opcja: -%c\n"), optopt);
	    else
		fprintf(stderr, _("Nierozpoznana opcja: -\\x%x\n"),
			optopt);
	    return EXIT_FAILURE;
	    break;
	}
    init_();
    koniec = 0;
    przerysuj = 1;
    refresh_opisu = 1;
    widocznosc(&Poziom, Poziom.Istoty.poczatek->nast);
    rysuj_poziom(&Poziom);
/* -------------------------------------------------------------------------- 
 *                     POCZTEK GWNEJ PTLI                            */
    while (!koniec) {
#ifdef DEBUG
	if (wmove(wPoziom, Gracz->y - Poziom.sy, Gracz->x - Poziom.sx) ==
	    ERR) {
	    beep();
	}
#endif
	rusz_postacie(&Poziom);
/* Sprawdmy, czy przypadkiem nie ma wojny :) */
	if (!koniec)
	    obsluz_zdarzenia(-1);
/* Jak nam si zmaro, to... */
	if (Gracz->flagi & FLAGA_SMIERCI) {
	    koniec = 1;
	}
/* Licznik do systemu szybkoci */
	licznik_szybkosci++;
/* Licznik tur */
	tura++;
	if (refresh_opisu) {
	    wyswietl_opis_gracza(&Poziom);

	}
	refresh_opisu = 0;
    }
/* --------------------------------------------------------------------------
 *                           KONIEC GWNEJ PTLI
 *                                                                        */
    rysuj_poziom(&Poziom);
    rysuj_postacie(&Poziom);
    rysuj_przedmioty(&Poziom, &Poziom.Przedmioty);
    wyczysc_gore();
    strcpy(tmp2, _("\nPowd mierci: "));
    strcat(tmp2, powod_smierci);
    strcat(tmp2, _(" \nNacinij co."));
    dodaj_napis(tmp2);
    wyswietl_opis_gracza(&Poziom);
    Poziom.Istoty.aktualny = Gracz;
    zabij_potwora(&Poziom.Istoty, &Poziom);
    wrefresh(wOpis);
    wrefresh(wGora);
    zakoncz_io();
    pobierz_klawisz();
    tempek = umiesc_w_tablicy();
    wyswietl_punktacje(tempek);
    zapisz_punkty();
    zakoncz();			/* Ncurses */
    end_locale();
    exit(0);
    return 0;
}
