#include "io.h"

WINDOW *wEnter;
int lib_data_opened;

void init_io()
{
    struct stat st;
    char sciezka[1000];
#ifdef LINUX
    pid = getpid();
#endif
    lib_data_opened = 0;
    strcpy(sciezka, ".");
#ifdef LINUX
    strcpy(sciezka, getenv("HOME"));
#endif
    strcat(sciezka, "/.LIB");
#ifdef DJGPP
    otworz_plik("./lib.dat", data, &Plik);
#else
    otworz_plik("./lib.data", data, &Plik);
#endif
    if (!lib_data_opened) {
	otworz_plik(LIBDIR "/lib.data", data, &Plik);
	if (!lib_data_opened) {
	    wprintw(wEkran,
		    _("Nie mog znale lib.data!\nNacinij co. "));
	    wrefresh(wEkran);
	    pobierz_klawisz();
	    zakoncz();
	    exit(1);
	}
    }
    if (stat(sciezka, &st)) {
	mkdir(sciezka, 0700);
    }
    strncpy(sciezka_do_domowego, sciezka, 1000);
    strcat(sciezka, "/lib.tmp");
    strncpy(sciezka_do_tmpliku, sciezka, 1000);
    strncpy(sciezka, sciezka_do_domowego, 1000);
    strcat(sciezka, "/lib.pid");
    if (!stat(sciezka, &st)) {
#ifdef LINUX
	pid_t old_pid;
	pidfile = fopen(sciezka, "rb");
	fscanf(pidfile, "%d", &old_pid);
	if (!kill(old_pid, 0)) {
	    fclose(pidfile);
#endif
	    zakoncz();
#ifdef LINUX
	    printf(_("Inna kopia programu zostaa uruchomiona. (%d) \n"),
		   old_pid);
#endif
#if defined(CYGWIN) || defined(_DJGPP)
	    printf(_("Inna kopia programu zostaa uruchomiona. \n"));
#endif
	    exit(1);
#ifdef LINUX
	}
	fclose(pidfile);
#endif
    }
    pidfile = fopen(sciezka, "wb");
#ifdef LINUX
    fprintf(pidfile, "%d", pid);
#endif
#if defined(CYGWIN) || defined(_DJGPP)
    fprintf(pidfile, "%d", 0);
#endif
    fclose(pidfile);
    Pliktmp.strumykz = fopen(sciezka_do_tmpliku, "wb");
    strncpy(Pliktmp.nazwa, "lib.tmp", 8);
    Pliktmp.ile_tablic = 0;

}

void zakoncz_io()
{
    char sciezka[1000];
    fclose(Plik.strumyk);
    fclose(Pliktmp.strumykz);
    unlink(sciezka_do_tmpliku);
    strncpy(sciezka, sciezka_do_domowego, 1000);
    strcat(sciezka, "/lib.pid");
    unlink(sciezka);
}

/* Pobiera kierunek z num_pada */
void pobierz_kierunek(int klawisz, struct delta *Delta)
{
    if (klawisz == k_lewogora || klawisz == KEY_A1) {
	Delta->x = (-1);
	Delta->y = (-1);
	return;
    }
    if (klawisz == k_gora || klawisz == KEY_UP) {
	Delta->x = (0);
	Delta->y = (-1);
	return;
    }
    if (klawisz == k_prawogora || klawisz == KEY_A3) {
	Delta->x = (1);
	Delta->y = (-1);
	return;
    }
    if (klawisz == k_lewo || klawisz == KEY_LEFT) {
	Delta->x = (-1);
	Delta->y = (0);
	return;
    }
    if (klawisz == k_centrum || klawisz == KEY_B2) {
	Delta->x = (0);
	Delta->y = (0);
	return;
    }
    if (klawisz == k_prawo || klawisz == KEY_RIGHT) {
	Delta->x = (1);
	Delta->y = (0);
	return;
    }
    if (klawisz == k_lewodol || klawisz == KEY_C1) {
	Delta->x = (-1);
	Delta->y = (1);
	return;
    }
    if (klawisz == k_dol || klawisz == KEY_DOWN) {
	Delta->x = (0);
	Delta->y = (1);
	return;
    }
    if (klawisz == k_prawodol || klawisz == KEY_C3) {
	Delta->x = (1);
	Delta->y = (1);
	return;
    }

    Delta->x = NIE_KIERUNEK;


}

int pobierz_klawisz()
{
    int klawisz;
    klawisz = wgetch(wEnter);
    return klawisz;
}

/* Otwiera plik i aduje go do Plik (do pniejszego uytku) */
void otworz_plik(char nazwa[25], FILE * strumyk, struct _plik *Plik)
{
    int i;
    if ((strumyk = fopen(nazwa, "rb")) == NULL) {
        fprintf(stderr, "Nie mog otworzy pliu %s\n", nazwa);
	return;
    }
    lib_data_opened = 1;
    Plik->strumyk = strumyk;
    strcpy(Plik->nazwa, nazwa);
    fread(&Plik->ile_tablic, sizeof(Plik->ile_tablic), 1, strumyk);
    for (i = 0; i < Plik->ile_tablic; i++) {
	fread(&Plik->tablica[i], sizeof(struct __tablica), 1, strumyk);
	fseek(strumyk,
	       Plik->tablica[i].offset + Plik->tablica[i].wielkosc_comp,
	       SEEK_SET);
    }
}

/* Ustawia wskanik pliku na wskazan (przez ID) tablic, odkompresowuje j 
 * i przygotowuje wpisy w Plik dotyczce bufora */
int ustaw_plik(struct _plik *Plik, char ID[5])
{
    int i, wynik;
    int blad;
    char *buf_comp;
    int wlk_saved;
    wynik = 0;
    for (i = (Plik->ile_tablic - 1); (i >= 0) && (!wynik); i--)
	if (!strcmp(Plik->tablica[i].ID, ID)) {
	    buf_comp = my_malloc(Plik->tablica[i].wielkosc_comp);
	    wlk_saved = Plik->tablica[i].wielkosc;
	    fseek(Plik->strumyk, Plik->tablica[i].offset, SEEK_SET);
	    if (fread
		(buf_comp, Plik->tablica[i].wielkosc_comp, 1, Plik->strumyk) == -1) {
		fprintf(stderr, _("Bd czytania segmentu %s: %d!\n"), ID,
			ferror(Plik->strumyk));
		exit(EXIT_FAILURE);
	    }
	    blad =
		uncompress(Plik->buforek, &Plik->tablica[i].wielkosc,
			   buf_comp, Plik->tablica[i].wielkosc_comp);
	    if (blad != Z_OK) {
		fprintf(stderr,
			_
			("Bd przy dekompresji %s (%ld) (compr: %ld, uncompr: %d (%d)) !\n"),
			ID, Plik->tablica[i].wielkosc_comp,
			Plik->tablica[i].wielkosc, wlk_saved, blad);
		exit(EXIT_FAILURE); 
	    }
	    Plik->wielkosc = Plik->tablica[i].wielkosc;
	    Plik->offset = 0;
	    wynik = 1;
	    ustawiony = i;
	    my_free(buf_comp);
	}
    return wynik;
}

void dodaj_do_pliku(void *co, char *sygnaturka, struct _plik *plik_wyj)
{
    char *dup_comp, *dupka;
    long int ile, ile_comp = MAXTAB;
    struct __tablica Tablica;
    int blad;
    dupka = my_malloc(wielkosc_ostatniej_tablicy);
    dup_comp = my_malloc(wielkosc_ostatniej_tablicy * 2 + 13); /* XXX Troch za duo... */
    memcpy(dupka, co, wielkosc_ostatniej_tablicy);
    ile = wielkosc_ostatniej_tablicy;
    blad = compress(dup_comp, &ile_comp, dupka, ile);
    my_free(dupka);
    if (blad != Z_OK) {
	fprintf(stderr, _("Bd przy kompresji %s (%d)!\n"), sygnaturka,
		blad);
	exit(EXIT_FAILURE);
    }
    Tablica.wielkosc = ile;
    Tablica.wielkosc_comp = ile_comp;
    strcpy(Tablica.ID, sygnaturka);
    Tablica.offset = ftell(plik_wyj->strumykz) + sizeof(Tablica);
    fwrite( &Tablica, sizeof(Tablica), 1, plik_wyj->strumykz);
    fwrite(dup_comp, ile_comp, 1, plik_wyj->strumykz);
    my_free(dup_comp);
    plik_wyj->tablica[plik_wyj->ile_tablic] = Tablica;
    plik_wyj->ile_tablic++;
}

void
dodaj_tablice_do_pliku(char *sygnaturka, struct _plik *wejscie,
		       struct _plik *wyjscie)
{
    ustaw_plik(wejscie, sygnaturka);
    wielkosc_ostatniej_tablicy = wejscie->tablica[ustawiony].wielkosc;
    dodaj_do_pliku(wejscie->buforek, sygnaturka, wyjscie);
}

void sread(struct _plik *skad, void *buf, size_t ile)
{
    char *buf2;
    buf2 = memcpy(buf, &skad->buforek[skad->offset], ile);
    skad->offset += ile;
}

int sgetc(struct _plik *skad)
{
    int wynik =
	(unsigned short int) (unsigned char) skad->buforek[skad->offset];
    skad->offset++;
    return wynik;
}
