/* keymap.h  mapa klawiatury */
#ifndef KEYMAP_H
#define KEYMAP_H

#include <string.h>
#include "config.h"
#include "io.h"
#include "parser.h"

#define K_KONIEC		'Q'
#define K_LEWOGORA		'7'
#define K_GORA			'8'
#define K_PRAWOGORA		'9'
#define K_LEWO			'4'
#define K_CENTRUM		'5'
#define K_PRAWO			'6'
#define K_LEWODOL		'1'
#define K_DOL			'2'
#define K_PRAWODOL		'3'
#define K_EKWIPUNEK		'e'
#define K_ZAMKNIJ		'z'
#define K_OTWORZ		'o'
#define K_PIJ			'p'
#define K_PODNIES		','
#define K_POLOZ			'd'
#define K_CZYTAJ		'c'
#define K_PLECAK		'i'
#define K_JEDZ			'j'
#define K_ZEJDZ			'>'
#define K_WEJDZ			'<'
#define K_PATRZ			'l'
#define K_PLAC			'P'
#define K_ROZMAWIAJ		'r'
#define K_KEYMAP		'k'
#define K_ZAPISZ		'S'
#define K_UMIEJETNOSCI		'U'
#define K_STATUS		's'
#define K_POZYCJA		'0'
#define K_STRZELAJ		'f'
#define K_RZUCAJ		't'

#ifdef DEBUG
#define K_DEBUG2          'w'
#define K_DEBUG3          'W'
#define K_DEBUG7          'S'
#endif

#define K_PREFIKS         ':'	/* Znak specjalny do poprzedzania komend nastpnych: */
#define K_BUFOR           'M'	/* Wywietlenie bufora tekstu */
#define K_CZAS            'c'	/* Wywietlenie aktualnego czasu */
#define K_BRON		  'B'	/* Wywietlenie skutecznoci broni */

#ifdef DEBUG
#define K_DEBUG1          'L'
#define K_DEBUG4	  'K'
#define K_DEBUG5          'G'
#define K_DEBUG6          'T'
#define K_DEBUG8          'W'
#define K_DEBUG9          'D'
#define K_DEBUG10         'P'
#define K_DEBUG11         'p'
#define K_DEBUG12	  'w'
#define K_DEBUG13	  'o'
#define K_DEBUG14	  'q'
#endif

int laduj_mape;

/* A tu si zaczyna rzeczywista mapa klawiatury  */

char k_koniec;
char k_lewogora;
char k_gora;
char k_prawogora;
char k_lewo;
char k_centrum;
char k_prawo;
char k_lewodol;
char k_dol;
char k_prawodol;
char k_ekwipunek;
char k_zamknij;
char k_otworz;
char k_pij;
char k_podnies;
char k_poloz;
char k_czytaj;
char k_plecak;
char k_jedz;
char k_zejdz;
char k_wejdz;
char k_patrz;
char k_plac;
char k_rozmawiaj;
char k_keymap;
char k_zapisz;
char k_umiejetnosci;
char k_status;
char k_pozycja;
char k_strzelaj;
char k_rzucaj;

#ifdef DEBUG
char k_debug2;
char k_debug3;
char k_debug7;
#endif

char k_prefiks;
char k_bufor;
char k_czas;
char k_bron;

#ifdef DEBUG
char k_debug1;
char k_debug4;
char k_debug5;
char k_debug6;
char k_debug8;
char k_debug9;
char k_debug10;
char k_debug11;
char k_debug12;
char k_debug13;
char k_debug14;
#endif

void init_keymap();
#endif
