/* przedmioty.h */
#ifndef przedmioty_h
#define przedmioty_h

#include <stdlib.h>
#include <unistd.h>
#include "config.h"
#include "io.h"
#include "structpostac.h"
#include "structprzedmioty.h"
#include "przedmioty_dod.h"
#include "structprzedmiotyID.h"
#include "ekran.h"
#include "rozne.h"

#define ZLOTO '$'

#ifdef DEBUG
int pokazuj_parametry;
#endif

char literki[ILE_LITEREK];

void wczytaj_tablice_prz_ID(struct _plik *in,
			    struct PrzedmiotyID *tablica);

void zapisz_tablice_prz_ID(char *out, long int *ile,
			   struct PrzedmiotyID tablica);

void wczytaj_przedmioty(struct _plik *in, struct przedmioty *Przedmioty);

void wczytaj_przedmioty_kr(struct _plik *in,
			   struct przedmioty *Przedmioty);

void zapisz_przedmioty(char *out, long int *ile,
		       struct przedmioty *Przedmioty);

void wczytaj_tablice_preID(struct _plik *in);

void zapisz_tablice_wyk_preID(char *out, long int *ile);
void wczytaj_tablice_wyk_preID(struct _plik *in);
void wczytaj_tablice_znanych(struct _plik *in);
void zapisz_tablice_znanych(char *out, long int *ile);
short int szukaj_nastepny(int x, int y, struct przedmioty *Przedmioty);

/* Szuka kolejnego niezapaconego przedmiotu, zwraca ZNALAZL albo NIE_ZNALAZL */
short int znajdz_niezaplacony(struct przedmioty *Przedmioty);
int
dodaj_przedmiot(int x, int y, int ilosc, int ID, int flagi,
		struct przedmioty *Przedmioty);

int dodaj_dokladnie(int x, int y, int ile, struct przedmiot *co,
		    struct przedmioty *gdzie);

int usun_przedmiot(struct przedmioty *Przedmioty, int ile);

void zniszcz_przedmiot(struct przedmioty *Przedmioty);

int dodaj_ladnie(int x, int y, int ilosc, int ID, int flagi, int cena,
		 struct przedmioty *Przedmioty);

void wyczysc_liste_przedmiotow(struct przedmioty *Przedmioty);

void dodaj_z_literkami(struct przedmiot *Przedmiot, struct istota *Postac,
		       int ile);

int dodaj_dokladnie_z_literkami(struct przedmiot *Przedmiot,
				struct istota *Postac, int ile);

void obsluz_ekwipunek(struct istota *Postac, int n);

void dodaj_do_ekwipunku(struct istota *Postac, int miejsce);

void wyjmij_z_ekwipunku(struct istota *Postac, int miejsce);

char *nazwa_ekw(int n, struct ekwipunek *ekw, char *bufor);

void usun_z_plecaka_przedmiot(struct przedmioty *Przedmioty);

/* Zwraca ID losowego przedmiotu z klasy */
int szukaj_przedmiotu_z_klasy(long int klasa, int poziom);

int szukaj_wiekszego_przedmiotu_z_klasy(long int klasa, int podklasa,
					int poziom, int wielkosc);

/* Zwraca ID losowego przedmiotu */
int szukaj_przedmiotu_z_poziomu(int poziom);

/* Szuka przedmiotu identycznego z P */
short int szukaj_takiego(struct przedmiot *P, struct przedmioty *Py);

/* Szuka przedmiotu identycznego z P, ktry nim nie jest */
short int szukaj_innego_takiego(struct przedmiot *P,
				struct przedmioty *Py);

char *nazwa_materialu(int ktorego, char *buf, int rodzaj, int liczba,
		      int przypadek);

short int szukaj_tego(wskaznik_przedmiot P, struct przedmioty *Py);
/* Zdejmuje flagi flagi z przedmiotw istniejcych na licie Py */
void zdejmij_flagi_z_przedmiotow(struct przedmioty *Py, int flagi);

/* Wypenia pola struktury przedmiotu zgodnie z jego ID */
void zrob_przedmiot(struct przedmiot *P);

void podnies_przedmiot(struct poziom *Poziom, struct istota *Postac);
int gr_poloz_przedmioty(struct poziom *Poziom, struct istota *Postac);
int gr_podnies_przedmioty(struct poziom *Poziom, struct istota *Postac);

/* Liczy aktualne czstoci dla przedmiotyID */
void policz_czestosci(int poziom, struct PrzedmiotyID *P);

void init_materialow();
char *nazwa_przedmiotu(struct przedmiot *P, char *buf, int przypadek);

int wybierz_z_napojow_preID();
int wybierz_ze_zwojow_preID();
int uszkodzenie_przedmiotu(struct przedmiot *P, int sila);
#endif
