/* swiat.h */
#ifndef SWIAT_H
#define SWIAT_H

#include "config.h"

#include <strings.h>
#include "ekran.h"
#include "poziom.h"
#include "zadania.h"
#include "czas.h"
#include "io.h"
#include "poziomconst.h"

unsigned long int tura;


struct kratka {
    short int wygenerowane;	/* 1 - jeeli ju wygenerowane */
    char nazwa[5];		/* "MSTO1" itp. */
    int poziom;			/* Poziom trudnoci */
    int maxx, maxy;
    int dx, dy;
    long int flagi;
    int gen_potw_tur;
    int gen_potw_l;
    int typ;			/* typ dla generatora (-1 jeeli od zawsze wygenerowane) */
    int droga;			/* typ drogi: (suma flag dla odpowiednich punktw)
				 *            1
				 *         2     4
				 *            8
				 */
};

struct _swiat {
    struct kratka pole[SWX][SWY][SWZ];
    int x, y, z;		/* aktualna kratka */
} swiat;

/* Typy zdarze:
 * 0 - komunikat jeno...
 * 1 - komunikat i zadanie zabicia kogo/czego
 * 2 - komunikat i przedmiot
 */

struct Zdarzenie {
    unsigned short int typ;
    char komunikat[10000];
    struct _czas start, stop;	/* Przedzia czasu, w jakim aktywne
				   jest zdarzenie
				   (.rok=0, kiedy nie istnieje granica) 
				   w dow. polu -1 znaczy tyle, co '*' w cronie */
    unsigned short int spelnione;	/* Czy ju zaszo */
    unsigned short int aktualne;	/* czy zdarzenie moe zaj :) */
    unsigned short int jednorazowe;
    int nr_przedmiotu;		/* w ramach nagrody (-1 jeeli nie ma); */
    int nr_potwora;		/* w ramach questa ... s/quest/zadanie/g */
    int nr_zdarzenia;		/* ktre zdarzy si po wypenieniu zadania (-1 jeli takowego nie ma */
    int dawca;			/* ID dajcego zadanie (-1 jeeli brak) */
    int wykonane;		/* Numer zdarzenia, ktre musi zaj wczeniej (albo -1) */
/*    wsk_istota wykonawca; *//* zadania */
    int nr_zadania;		/* w tablicy wykonawcy */
} zdarzenie[MAXZD];

int ile_zdarzen;

void wczytaj_swiat(struct _plik *plik, struct _swiat *Swiat);

void wczytaj_zdarzenia(struct _plik *in);
void zapisz_zdarzenia(char *out, long int *ile);

void init_swiata();

void obsluz_zdarzenia(int potw);

#endif
