/* trasy.h */
/* Trasy potworw poruszajcych si po miastach i innych uprzednio narysowanych miejscach */
#ifndef TRASY_H
#define TRASY_H

#include "config.h"
#include "io.h"

/* Tras okrelamy podajc kolejne ruchy znakami:
 * 0-9    - kolejne zaznaczone miejsca na mapie 
 * NWSE   - kierunki
 * K      - kup
 * Z      - zamknij
 * O      - otworz
 *       - szukaj wolnego ka
 */

#define TRASA_JEDZENIE_ZE_SKLEPU	0
#define TRASA_PO_PRZEBUDZENIU		1
#define TRASA_PO_ZMROKU			2
#define TRASA_STRAZNIKA			3

struct _miejsce {
    int x, y;
    char literka;
} miejsce[MAXMIEJSC];

int ile_miejsc;

struct _trasa {
    char c[MAXPOTWOROW][MAXTRAS][MAXDLTRASY];	/* trasa */
    int m[MAXPOTWOROW][MAXTRAS];	/* miejsce */
    int a[MAXPOTWOROW];		/* aktywna trasa */
} trasa;

void wyczysc_miejsca();
void wyczysc_trasy();
void laduj_miejsca(struct _plik *plik);
void zapisz_miejsca(char *out, long int *ile);
void laduj_trasy(struct _plik *plik);
int szukaj_miejsca(char literka);
#endif
